<template>
  <div class="app-container">
    <div class="filter-container">
      <el-input v-model="query.title" :placeholder="$t('table.title')" style="width: 200px;" class="filter-item" @keyup.enter.native="handleFilter" />
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFilter">
        {{ $t('table.search') }}
      </el-button>
    </div>
    <el-table v-loading="listLoading" :data="list" border fit highlight-current-row style="width: 100%">
      <el-table-column align="center" :label="$t('form.name')">
        <template slot-scope="scope">
          <span>{{ scope.row.name }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('form.accountNumber')">
        <template slot-scope="scope">
          <span>{{ scope.row.account_number }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('form.shabaNumber')">
        <template slot-scope="scope">
          <span>{{ scope.row.shaba }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('form.accountId')">
        <template slot-scope="scope">
          <span>{{ scope.row.card_id }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('form.status')">
        <template slot-scope="scope">
          <span>{{ $t('form.' + scope.row.status) }}</span>
        </template>
      </el-table-column>
      <el-table-column align="center" :label="$t('row.operation')">
        <template slot-scope="scope">
          <span class="pointer fa fa-check mr-1 ml-1" @click="acceptBani(scope.row.id)">&nbsp;</span>
          <span class="pointer fa fa-remove mr-1 ml-1" @click="rejectBani(scope.row.id)">&nbsp;</span>
        </template>
      </el-table-column>

    </el-table>

    <pagination v-show="total>0" :total="total" :page.sync="query.page" :limit.sync="query.limit" @pagination="getList" />
  </div>
</template>

<script>
import Pagination from '@/components/Pagination'; // Secondary package based on el-pagination
import Bani from '@/api/bani';
const baniResource = new Bani('bani');
import 'vue-select/src/scss/vue-select.scss';
// import i18n from '@/lang';

export default {
  name: 'BaniList',
  components: { Pagination },
  filters: {
    statusFilter(status) {
      const statusMap = {
        published: 'success',
        draft: 'info',
        deleted: 'danger',
      };
      return statusMap[status];
    },
  },
  data() {
    return {
      list: null,
      total: 0,
      manage: {},
      listLoading: true,
      dialogFormVisible: false,
      dialogFormListVisible: false,
      transferAddress: false,
      query: {
        page: 1,
        limit: 15,
        title: '',
        role: '',
      },
      options: [],
    };
  },
  created() {
    this.getList();
  },
  methods: {
    async getList() {
      this.listLoading = true;
      const { result } = await baniResource.list(this.query);
      this.list = result.rows;
      this.total = result.total;
      this.listLoading = false;
    },
    rejectBani() {
      this.$confirm(this.$i18n.t(`dialog.isReject`), this.$i18n.t(`dialog.warning`), {
        confirmButtonText: this.$i18n.t(`dialog.confirm`),
        cancelButtonText: this.$i18n.t(`dialog.cancel`),
        type: 'warning',
      })
        .then(async() => {
          alert('asdasd');
        })
        .catch(err => {
          console.error(err);
        });
    },
    acceptBani(id) {
      this.manage.id = id;
      this.$confirm(this.$i18n.t(`dialog.isAccept`), this.$i18n.t(`dialog.confirm`), {
        confirmButtonText: this.$i18n.t(`dialog.confirm`),
        cancelButtonText: this.$i18n.t(`dialog.cancel`),
        type: 'success',
      })
        .then(async() => {
          const result = await baniResource.accept(this.manage);
          if (result.success === true) {
            this.getList();
          }
        })
      // .catch(err => {})
      ;
    },
    handleFilter() {
      this.query.page = 1;
      this.getList();
    },
    onSearch(search, loading) {
      fetch(
        '/api/searchUsers?q=' + search
      ).then(res => {
        res.json().then(json => (this.options = json.items));
        console.log(this.options);
        loading(false);
      });
    },
  },
};
</script>
